package com.sun.corba.se.impl.dynamicany;

import java.io.Serializable;
import org.omg.CORBA.Object;
import org.omg.CORBA.TypeCodePackage.BadKind;
import org.omg.DynamicAny.DynAnyFactoryPackage.InconsistentTypeCode;
import org.omg.DynamicAny.DynAnyPackage.InvalidValue;
import org.omg.DynamicAny.DynAnyPackage.TypeMismatch;
import org.omg.DynamicAny.DynAny;
import org.omg.CORBA.TypeCode;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.CORBA.Any;

public class DynAnyBasicImpl extends DynAnyImpl
{
    private DynAnyBasicImpl() {
        this(null, (Any)null, false);
    }
    
    protected DynAnyBasicImpl(ORB orb, Any any, boolean b) {
        super(orb, any, b);
        this.index = -1;
    }
    
    protected DynAnyBasicImpl(ORB orb, TypeCode typeCode) {
        super(orb, typeCode);
        this.index = -1;
    }
    
    @Override
    public void assign(DynAny dynAny) throws TypeMismatch {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        super.assign(dynAny);
        this.index = -1;
        return;
    }
    
    @Override
    public void from_any(Any any) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        super.from_any(any);
        this.index = -1;
        return;
    }
    
    @Override
    public Any to_any() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        return DynAnyUtil.copy(this.any, this.orb);
    }
    
    @Override
    public boolean equal(DynAny dynAny) {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        return dynAny == this || (this.any.type().equal(dynAny.type()) && this.any.equal(this.getAny(dynAny)));
    }
    
    @Override
    public void destroy() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.status == 0) {
            this.status = 2;
        }
        return;
    }
    
    @Override
    public DynAny copy() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        try {
            return DynAnyUtil.createMostDerivedDynAny(this.any, this.orb, true);
        }
        catch (InconsistentTypeCode inconsistentTypeCode) {
            return null;
        }
    }
    
    public DynAny current_component() throws TypeMismatch {
        return null;
    }
    
    public int component_count() {
        return 0;
    }
    
    public boolean next() {
        return false;
    }
    
    public boolean seek(int n) {
        return false;
    }
    
    public void rewind() {
    }
    
    public void insert_boolean(boolean b) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 8) {
            throw new TypeMismatch();
        }
        this.any.insert_boolean(b);
        return;
    }
    
    public void insert_octet(byte b) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 10) {
            throw new TypeMismatch();
        }
        this.any.insert_octet(b);
        return;
    }
    
    public void insert_char(char c) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 9) {
            throw new TypeMismatch();
        }
        this.any.insert_char(c);
        return;
    }
    
    public void insert_short(short n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 2) {
            throw new TypeMismatch();
        }
        this.any.insert_short(n);
        return;
    }
    
    public void insert_ushort(short n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 4) {
            throw new TypeMismatch();
        }
        this.any.insert_ushort(n);
        return;
    }
    
    public void insert_long(int n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 3) {
            throw new TypeMismatch();
        }
        this.any.insert_long(n);
        return;
    }
    
    public void insert_ulong(int n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 5) {
            throw new TypeMismatch();
        }
        this.any.insert_ulong(n);
        return;
    }
    
    public void insert_float(float n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 6) {
            throw new TypeMismatch();
        }
        this.any.insert_float(n);
        return;
    }
    
    public void insert_double(double n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 7) {
            throw new TypeMismatch();
        }
        this.any.insert_double(n);
        return;
    }
    
    public void insert_string(String s) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 18) {
            throw new TypeMismatch();
        }
        if (s == null) {
            throw new InvalidValue();
        }
        try {
            if (this.any.type().length() > 0 && this.any.type().length() < s.length()) {
                throw new InvalidValue();
            }
        }
        catch (BadKind badKind) {}
        this.any.insert_string(s);
        return;
    }
    
    public void insert_reference(Object object) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 14) {
            throw new TypeMismatch();
        }
        this.any.insert_Object(object);
        return;
    }
    
    public void insert_typecode(TypeCode typeCode) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 12) {
            throw new TypeMismatch();
        }
        this.any.insert_TypeCode(typeCode);
        return;
    }
    
    public void insert_longlong(long n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 23) {
            throw new TypeMismatch();
        }
        this.any.insert_longlong(n);
        return;
    }
    
    public void insert_ulonglong(long n) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 24) {
            throw new TypeMismatch();
        }
        this.any.insert_ulonglong(n);
        return;
    }
    
    public void insert_wchar(char c) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 26) {
            throw new TypeMismatch();
        }
        this.any.insert_wchar(c);
        return;
    }
    
    public void insert_wstring(String s) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 27) {
            throw new TypeMismatch();
        }
        if (s == null) {
            throw new InvalidValue();
        }
        try {
            if (this.any.type().length() > 0 && this.any.type().length() < s.length()) {
                throw new InvalidValue();
            }
        }
        catch (BadKind badKind) {}
        this.any.insert_wstring(s);
        return;
    }
    
    public void insert_any(Any any) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 11) {
            throw new TypeMismatch();
        }
        this.any.insert_any(any);
        return;
    }
    
    public void insert_dyn_any(DynAny dynAny) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 11) {
            throw new TypeMismatch();
        }
        this.any.insert_any(dynAny.to_any());
        return;
    }
    
    public void insert_val(Serializable s) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        int value = this.any.type().kind().value();
        if (value != 29 && value != 30) {
            throw new TypeMismatch();
        }
        this.any.insert_Value(s);
        return;
    }
    
    public Serializable get_val() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        int value = this.any.type().kind().value();
        if (value != 29 && value != 30) {
            throw new TypeMismatch();
        }
        return this.any.extract_Value();
    }
    
    public boolean get_boolean() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 8) {
            throw new TypeMismatch();
        }
        return this.any.extract_boolean();
    }
    
    public byte get_octet() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 10) {
            throw new TypeMismatch();
        }
        return this.any.extract_octet();
    }
    
    public char get_char() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 9) {
            throw new TypeMismatch();
        }
        return this.any.extract_char();
    }
    
    public short get_short() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 2) {
            throw new TypeMismatch();
        }
        return this.any.extract_short();
    }
    
    public short get_ushort() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 4) {
            throw new TypeMismatch();
        }
        return this.any.extract_ushort();
    }
    
    public int get_long() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 3) {
            throw new TypeMismatch();
        }
        return this.any.extract_long();
    }
    
    public int get_ulong() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 5) {
            throw new TypeMismatch();
        }
        return this.any.extract_ulong();
    }
    
    public float get_float() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 6) {
            throw new TypeMismatch();
        }
        return this.any.extract_float();
    }
    
    public double get_double() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 7) {
            throw new TypeMismatch();
        }
        return this.any.extract_double();
    }
    
    public String get_string() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 18) {
            throw new TypeMismatch();
        }
        return this.any.extract_string();
    }
    
    public Object get_reference() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 14) {
            throw new TypeMismatch();
        }
        return this.any.extract_Object();
    }
    
    public TypeCode get_typecode() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 12) {
            throw new TypeMismatch();
        }
        return this.any.extract_TypeCode();
    }
    
    public long get_longlong() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 23) {
            throw new TypeMismatch();
        }
        return this.any.extract_longlong();
    }
    
    public long get_ulonglong() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 24) {
            throw new TypeMismatch();
        }
        return this.any.extract_ulonglong();
    }
    
    public char get_wchar() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 26) {
            throw new TypeMismatch();
        }
        return this.any.extract_wchar();
    }
    
    public String get_wstring() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 27) {
            throw new TypeMismatch();
        }
        return this.any.extract_wstring();
    }
    
    public Any get_any() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 11) {
            throw new TypeMismatch();
        }
        return this.any.extract_any();
    }
    
    public DynAny get_dyn_any() throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        if (this.any.type().kind().value() != 11) {
            throw new TypeMismatch();
        }
        try {
            return DynAnyUtil.createMostDerivedDynAny(this.any.extract_any(), this.orb, true);
        }
        catch (InconsistentTypeCode inconsistentTypeCode) {
            return null;
        }
    }
}
